"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QRCode = exports.DEFAULT_TEST_ID = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNativeSvg = _interopRequireWildcard(require("react-native-svg"));
var _useQRMatrix = require("../hooks/useQRMatrix");
var _useLogo = require("../hooks/useLogo");
var _reactNative = require("react-native");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const DEFAULT_TEST_ID = exports.DEFAULT_TEST_ID = 'react-native-qrcode-composer';
const QRCode = exports.QRCode = /*#__PURE__*/_react.default.memo(({
  value = 'QR code message',
  size = 100,
  logo,
  logoStyle,
  style,
  getRef,
  onError,
  testID = DEFAULT_TEST_ID
}) => {
  const matrixResult = (0, _useQRMatrix.useQRMatrix)({
    value,
    size,
    ...style
  });
  const {
    color = 'black',
    backgroundColor = 'white',
    quietZone = 0,
    linearGradient,
    gradientDirection = ['0%', '0%', '100%', '100%']
  } = style ?? {};
  const {
    logoComponent
  } = (0, _useLogo.useLogo)(size, `${testID}.logo`, logo, logoStyle);
  (0, _react.useEffect)(() => {
    if (matrixResult.status === 'failure') {
      onError?.(matrixResult.error);
    }
  }, [matrixResult]);
  if (matrixResult.status === 'success') {
    const {
      path
    } = matrixResult.value;
    const actualSize = size + quietZone * 2;
    return /*#__PURE__*/_react.default.createElement(_reactNativeSvg.default, {
      ref: getRef,
      viewBox: [-quietZone, -quietZone, actualSize, actualSize].join(' '),
      width: actualSize,
      height: actualSize,
      testID: `${testID}.qrcode`
    }, linearGradient !== undefined ? /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Defs, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.LinearGradient, {
      id: "grad",
      x1: gradientDirection[0],
      y1: gradientDirection[1],
      x2: gradientDirection[2],
      y2: gradientDirection[3]
    }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Stop, {
      offset: "0",
      stopColor: linearGradient[0],
      stopOpacity: "1"
    }), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Stop, {
      offset: "1",
      stopColor: linearGradient[1],
      stopOpacity: "1"
    }))) : null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.G, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
      x: -quietZone,
      y: -quietZone,
      width: actualSize,
      height: actualSize,
      fill: backgroundColor,
      rx: style?.cornerRadius,
      ry: style?.cornerRadius
    })), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.G, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Path, {
      d: path,
      fill: linearGradient !== undefined ? 'url(#grad)' : color,
      fillRule: "evenodd",
      testID: `${testID}.path`
    })), logoComponent !== null && logoComponent);
  }
  return onError === undefined ? /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    testID: `${testID}.error`
  }, matrixResult.error.message) : null;
});
//# sourceMappingURL=QRCode.js.map