"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useLogo = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNativeSvg = require("react-native-svg");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const isImageSourcePropType = logo => typeof logo === 'number' || typeof logo === 'object' && 'uri' in logo;
const isReactComponent = logo => typeof logo === 'function';
const logoBackgroundClipPath = 'logo-background-clip-path';
const logoClipPath = 'logo-clip-path';
const useLogo = (qrCodeSize, testId, logo, logoStyle) => {
  const logoComponent = (0, _react.useMemo)(() => {
    if (logo === undefined) {
      return null;
    }
    const {
      size = qrCodeSize * 0.2,
      backgroundColor = 'transparent',
      margin = 0,
      borderRadius = 0
    } = logoStyle ?? {};
    const marginOffset = margin * 2;
    const position = (qrCodeSize - size - marginOffset) / 2;
    const backgroundSize = size + marginOffset;
    const backgroundBorderRadius = borderRadius * (backgroundSize / 2);
    const LogoElement = isReactComponent(logo) ? logo : undefined;
    const logoImage = isImageSourcePropType(logo) ? logo : undefined;
    return /*#__PURE__*/_react.default.createElement(_reactNativeSvg.G, {
      x: position,
      y: position,
      testID: testId
    }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Defs, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.ClipPath, {
      id: logoBackgroundClipPath
    }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
      testID: `rect.${logoBackgroundClipPath}`,
      width: backgroundSize,
      height: backgroundSize,
      rx: backgroundBorderRadius,
      ry: backgroundBorderRadius
    })), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.ClipPath, {
      id: logoClipPath
    }, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
      testID: `rect.${logoClipPath}`,
      width: size,
      height: size,
      rx: borderRadius,
      ry: borderRadius
    }))), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.G, null, /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Rect, {
      testID: "rect.logo-background",
      width: backgroundSize,
      height: backgroundSize,
      fill: backgroundColor,
      clipPath: `url(#${logoBackgroundClipPath})`
    })), /*#__PURE__*/_react.default.createElement(_reactNativeSvg.G, {
      x: margin,
      y: margin,
      testID: "g.logo-container"
    }, LogoElement !== undefined ? /*#__PURE__*/_react.default.createElement(LogoElement, {
      width: size,
      height: size,
      clipPath: `url(#${logoClipPath})`
    }) : null, logoImage !== undefined ? /*#__PURE__*/_react.default.createElement(_reactNativeSvg.Image, {
      width: size,
      height: size,
      href: logoImage,
      clipPath: `url(#${logoClipPath})`
    }) : null));
  }, [logo, logoStyle, qrCodeSize]);
  return {
    logoComponent
  };
};
exports.useLogo = useLogo;
//# sourceMappingURL=useLogo.js.map