export const encodeQRCodeContents = contents => {
  if (typeof contents === 'string') {
    return contents;
  }
  switch (contents.type) {
    case 'plain-text':
      return contents.content;
    case 'url':
      return contents.url;
    case 'email':
      return 'mailto:';
    case 'phone':
      return 'tel:';
    case 'sms':
      return 'sms:';
    case 'wifi':
      return 'WIFI:';
    case 'geolocation':
      return 'geo:';
    case 'vcard':
      return 'BEGIN:VCARD';
    case 'mecard':
      return 'MECARD:';
    case 'calendar-event':
      return 'BEGIN:VEVENT';
    case 'bitcoin':
      return 'bitcoin:';
    case 'twitter':
      return 'https://twitter.com/';
  }
};
//# sourceMappingURL=QRContents.js.map